{0-Black,1-Blue, 2-Green, 3-Cyan, 4-Red, 5-Magenta, 6-Brown, 7-LightGray
11-LightCyan, 12-LightRed, 13-LightMagenta, 14-Yellow, 15-White         }

Unit Blaster;

Interface

procedure cleanwindow (x1, x2, y1, y2 : Byte);

function randstr (long : Byte) : String;
procedure starbox (minx, maxx, miny, maxy, colour : Byte);
procedure starbox2 (minx, maxx, miny, maxy, colour : Byte);

function no (x : Byte) : Boolean;
function bad (x : Byte) : Boolean;
function poor (x : Byte) : Boolean;
function baverage (x : Byte) : Boolean;
function average (x : Byte) : Boolean;
function aaverage (x : Byte) : Boolean;
function good (x : Byte) : Boolean;
function vgood (x : Byte) : Boolean;
function excellent (x : Byte) : Boolean;
function perfect (x : Byte) : Boolean;

function rate (x : Byte) : String;

function dayofweek (x : Byte) : String;

function trigger (x : LongInt) : Boolean;

function value (x : LongInt) : LongInt;

procedure cval (which : LongInt; how : LongInt);

function strval (x : LongInt) : String;

procedure cstr (which : LongInt; how : String);

procedure strigger (which : LongInt; how : Byte);

procedure strigger2 (dirname : String; which : LongInt; how : Byte);
function trigger2 (dirname : String;x : LongInt) : Boolean;

function percents (x, maxx : Word): Real;
function rpercents (x, maxx : Real): Real;

function hours (minute : Word) : Byte;

function shours (minute : Word) : String;

function sminutes (minute : Word) : String;

function minutes (minute : Word) : Byte;

procedure gowrite (x, y : Byte; wtext : String);

procedure gocwrite (x, y, color : Byte; wtext : String);

procedure linux (minx, maxx, miny, maxy, colour, stop : Byte);

function passline (nstring : Word; dbs, required : Byte) : Word;

function charvar (x : Char) : Word;

function varchar (x : Byte) : Char;

function intstring (x : Integer) : String;

procedure wait;

function filenumber (fstart, fend : String; number : Word) : String;

function level (x : LongInt; xlevel : Integer) : LongInt;
function reallevel (x : Real; xlevel : Integer) : Real;
function strans (wstring : String) : LongInt;
function sread : LongInt;
function sread2 (long : Byte): String;
function sread3 (long : Byte; typed : String; xchar : Char): String;

procedure dwrite (wstring : String; time : LongInt);
procedure dwriteln (wstring : String; time : LongInt);

procedure dwrite2 (wstring : String; time : LongInt; dook : Boolean);
procedure dwriteln2 (wstring : String; time : LongInt; dook : Boolean);

function colour (name : String) : Byte;
function filebchar (filename : String; line, chars : Word): Char;

procedure filewrite (filename : String; whichone, towhat : LongInt);
procedure fileswrite (filename : String; whichone : LongInt; towhat : String);

function fileread (filename : String; whichone : Word) : String;
function fileread2 (filename, dir : String; whichone : Word) : String;

function readint (filename, dir : String; length, line, int : Word) : Word; {last\best}
function readstr (filename, dir : String; length, line, int : Word) : String;{last\best}

function filereadvar (filename : String; whichone : Word) : LongInt;

function filereadb (filename : String; whichone : Word) : Boolean;

function stepcoord (step, miny, change : ShortInt) : ShortInt;

function filefound (filename : String) : Boolean;

procedure whitescreen (colour : ShortInt);

function filebstring (filename : String; line : Word): String;

function filebstring2 (filename, dir : String; line : Word): String;

function filestring (filename, start {sign of start read} : String;
anchor, {which entry read}lines {how much lines pass after sign} : Integer): String;

function filestring2 (filename, start : String; lines : Integer): String;

function fileint (filename, start, anchor {sign of start read} : String;
lines {which line after sign} : Integer): Integer;

function left (choice : char) : Boolean;
function right (choice : char) : Boolean;
function up (choice : char) : Boolean;
function down (choice : char) : Boolean;

function rup (choice : char) : Boolean;
function rdown (choice : char) : Boolean;

function lup (choice : char) : Boolean;
function ldown (choice : char) : Boolean;

procedure horline (minx, maxx, y, colour : ShortInt; sign : Char);
procedure verline (x, miny, maxy, colour : ShortInt; sign : Char);
procedure scan (y, z : Integer);
function oddnum (x : ShortInt) : Boolean;

Function arrow (x, miny, starty, maxy, step : Integer) : Integer;
Function sidearrow (x, miny, starty, maxy, step, isexit : Integer) : Integer;

procedure box (minx, maxx, miny, maxy, colour : ShortInt; sign : Char);
procedure squarebox (minx, maxx, miny, maxy, colour : ShortInt; sign : Char);
Procedure turnmove;
Procedure sign (x : Byte);
Procedure line;
Function timerate : LongInt;

function getname (g : Char) : String;

Implementation

uses Crt, Gamecube;

procedure cleanwindow (x1, x2, y1, y2 : Byte);
var i, i2 : Byte;
begin
for i:=1 to y2-y1-1 do begin
gotoxy (x1+1, y1+i);
for i2:=1 to x2-x1-1 do write (' ');
end;
end;



procedure starbox (minx, maxx, miny, maxy, colour : Byte);
var i : Byte;
begin
textcolor (colour);
gotoxy (minx, miny); write ('/');
for i:=minx+1 to maxx-1 do write ('-'); write ('\');
for i:=miny+1 to maxy-1 do begin
                                gotoxy (minx, i); write ('|');
                                gotoxy (maxx, i); write ('|');
                           end;
gotoxy (minx, maxy); write ('\');
for i:=minx+1 to maxx-1 do write ('-'); write ('/');
end;

procedure starbox2 (minx, maxx, miny, maxy, colour : Byte);
var i, i2 : Byte;
begin
textcolor (colour);
gotoxy (minx, miny); write ('/');
for i:=minx+1 to maxx-1 do write ('-'); write ('\');
for i:=miny+1 to maxy-1 do begin
                                gotoxy (minx, i); write ('|');
                                for i2:=minx+1 to maxx-1 do write (' ');
                                gotoxy (maxx, i); write ('|');
                           end;
gotoxy (minx, maxy); write ('\');
for i:=minx+1 to maxx-1 do write ('-'); write ('/');
end;


function randstr (long : Byte) : String;
var dice, letters, x : Byte;
    typing : String;
begin
if long=0 then begin
dice:=random(10)+1;
letters:=dice;
end else letters:=long;
x:=1;
repeat
dice:=random(122-97)+97;
if x=1 then typing:=chr(dice) else typing:=typing+chr(dice);
inc (x);
until (x>letters);
randstr:=typing;
end;

function dayofweek (x : Byte) : String;
begin
if x=1 then dayofweek:='쭨' else
if x=2 then dayofweek:='୨' else
if x=3 then dayofweek:='।' else
if x=4 then dayofweek:='⢥' else
if x=5 then dayofweek:='⭨' else
if x=6 then dayofweek:='㡡' else
if x=7 then dayofweek:='ᥭ' else
dayofweek:='祣';
end;

function rate (x : Byte) : String;
begin
if x<10 then rate:='' else
if (x>=10) and (x<20) then rate:='' else
if (x>=20) and (x<30) then rate:='' else
if (x>=30) and (x<40) then rate:=' 祭' else
if (x>=40) and (x<50) then rate:='।' else
if (x>=50) and (x<60) then rate:='' else
if (x>=60) and (x<70) then rate:='' else
if (x>=70) and (x<80) then rate:='. ' else
if (x>=80) and (x<90) then rate:='⫨筮' else
if (x>=90) and (x<=100) then rate:=''
else rate:=''
end;

function no (x : Byte) : Boolean;
begin
if x<10 then no:=true else no:=false;
end;

function bad (x : Byte) : Boolean;
begin
if (x>=10) and (x<20) then bad:=true else bad:=false;
end;

function poor (x : Byte) : Boolean;
begin
if (x>=20) and (x<30) then poor:=true else poor:=false;
end;

function baverage (x : Byte) : Boolean;
begin
if (x>=30) and (x<40) then baverage:=true else baverage:=false;
end;

function average (x : Byte) : Boolean;
begin
if (x>=40) and (x<50) then average:=true else average:=false;
end;

function aaverage (x : Byte) : Boolean;
begin
if (x>=50) and (x<60) then aaverage:=true else aaverage:=false;
end;

function good (x : Byte) : Boolean;
begin
if (x>=60) and (x<70) then good:=true else good:=false;
end;

function vgood (x : Byte) : Boolean;
begin
if (x>=70) and (x<80) then vgood:=true else vgood:=false;
end;

function excellent (x : Byte) : Boolean;
begin
if (x>=80) and (x<90) then excellent:=true else excellent:=false;
end;

function perfect (x : Byte) : Boolean;
begin
if (x>=90) and (x<=100) then perfect:=true else perfect:=false;
end;

function percents (x, maxx : Word) : Real;
begin
if x<>0 then percents:=x*100/maxx else percents:=0;
end;

function rpercents (x, maxx : Real) : Real;
begin
if x<>0 then rpercents:=x*100/maxx else rpercents:=0;
end;

function hours (minute : Word) : Byte;
var x : Word;
begin
x:=minute;
x:=x div 60;
hours:=x;
end;

function minutes (minute : Word) : Byte;
var x : Word;
begin
x:=minute;
x:=x mod 60;
minutes:=x;
end;

function sminutes (minute : Word) : String;
var x : Word;
    y : String;
begin
x:=minute;
x:=x mod 60;
str(x, y);
if x<10 then insert ('0', y, 1);
sminutes:=y;
end;

function shours (minute : Word) : String;
var x : Word;
    y : String;
begin
x:=minute;
x:=x div 60;
str(x, y);
if x<10 then insert ('0', y, 1);
shours:=y;
end;

procedure gowrite (x, y : Byte; wtext : String);
begin
gotoxy (x, y);
write (wtext);
end;

procedure gocwrite (x, y, color : Byte; wtext : String);
begin
gotoxy (x, y);
textcolor (color);
write (wtext);
end;


function level (x : LongInt; xlevel : Integer) : LongInt;
var i : ShortInt;
    z : LongInt;
begin
z:=x;
if xlevel<>1 then for i:=1 to xlevel-1 do z:=z*x;
if xlevel=0 then z:=1;
level:=z;
end;

function reallevel (x : Real; xlevel : Integer) : Real;
var i : ShortInt;
    z : Real;
begin
z:=x;
if xlevel<>1 then for i:=1 to xlevel-1 do z:=z*x;
if xlevel=0 then z:=1;
reallevel:=z;
end;

function charvar (x : Char) : Word;
var y : Word;
begin
if x='0' then y:=0 else
if x='1' then y:=1 else
if x='2' then y:=2 else
if x='3' then y:=3 else
if x='4' then y:=4 else
if x='5' then y:=5 else
if x='6' then y:=6 else
if x='7' then y:=7 else
if x='8' then y:=8 else
if x='9' then y:=9 else
y:=10;
charvar:=y;
end;

function varchar (x : Byte) : Char;
begin
if x=0 then varchar:='0' else
if x=1 then varchar:='1' else
if x=2 then varchar:='2' else
if x=3 then varchar:='3' else
if x=4 then varchar:='4' else
if x=5 then varchar:='5' else
if x=6 then varchar:='6' else
if x=7 then varchar:='7' else
if x=8 then varchar:='8' else
if x=9 then varchar:='9' else
varchar:='X';
end;



function strans (wstring : String) : LongInt;
var x : LongInt;
    intstring : String;
    i, numbers, written, minus : Byte;
begin
intstring:=wstring+';;';
x:=0;
i:=1;
written:=0;
minus:=0;
numbers:=0;

if intstring[1]='-' then begin
minus:=1;
inc (numbers);
inc (i);
end;

repeat
if (intstring[i]<>';') and (charvar(intstring[i])<10) then inc (numbers);
inc (i);
until intstring[i]=';';

i:=0;
for i:=numbers downto 1+minus do begin
x:=x+charvar(intstring[i])*level(10, written);
inc (written);
end;
if minus=1 then x:=x*-1;
strans:=x;
end;

function sread : LongInt;
var xstring : String;
    xchar   : Char;
begin
xstring:='';
repeat
xchar:=readkey;
if (charvar (xchar)<>10) and (length (xstring)<4) then begin
xstring:=xstring+xchar;
write (xchar);
end;
if (xchar=dodelete) and (length (xstring)>0) then begin
xstring:= copy (xstring, 1, length (xstring)-1);
gowrite (WhereX-1, WhereY, ' ');
gotoxy  (WhereX-1, WhereY);
end;
{readln (xstring);}
until xchar=#13;
{if length (xstring)>7 then sread:=0 else }sread:=strans(xstring);
end;



function sread2 (long : Byte): String;
var xstring : String;
    xchar   : Char;
    start_x, start_y, allletters, letter : Byte;


procedure erase;
begin
if (allletters>0) and (letter>0) then begin
delete (xstring, letter, 1);
dec (letter);
dec (allletters);

gowrite (WhereX, WhereY, ' ');
gotoxy  (WhereX-1, WhereY);
end;
end;

procedure eraseback;
begin
if (allletters>1) and (letter<allletters) then begin
delete (xstring, letter+1, 1);
dec (allletters);
end;
end;

begin
xstring:='';
letter:=0;
allletters:=0;
start_x:=wherex;
start_y:=wherey;


repeat

gowrite (start_x, start_y, xstring);
write (' ');
gotoxy (start_x+letter, start_y);

xchar:=readkey;

if (left (xchar))  then begin if letter>0 then dec (letter) end else
if (right (xchar)) then begin if letter<allletters then inc (letter) end else

if (ord (xchar)=8) then erase else if (ord (xchar)=83 ) then eraseback else

{if ((ord (xchar)<>83) and (ord (xchar)<>8)) and
   ((ord (xchar)>=33) or (ord (xchar)<=126)) and
   ((allletters<=long)) then begin}

if ((((xchar<>#83) and (xchar<>'<') and (xchar<>'>'))) and (((xchar>=#224) and (xchar<=#239))
or ((xchar>=#33) and (xchar<=#175))) or (((xchar=' '))))

   and (((allletters<long))) then begin


insert (xchar, xstring, letter+1);
{xstring:=xstring+xchar;}
inc (letter);
inc (allletters);
end;

{xstring:= copy (xstring, 1, length (xstring)-1);}


until xchar=#13;
sread2:=xstring;
end;



function sread3 (long : Byte; typed : String; xchar : Char): String;
var xstring : String;
{    xchar   : Char;}
    start_x, start_y, allletters, letter : Byte;


procedure erase;
begin
if (allletters>0) and (letter>0) then begin
delete (xstring, letter, 1);
dec (letter);
dec (allletters);

gowrite (WhereX, WhereY, ' ');
gotoxy  (WhereX-1, WhereY);
end;
end;

procedure eraseback;
begin
if (allletters>1) and (letter<allletters) then begin
delete (xstring, letter+1, 1);
dec (allletters);
end;
end;

begin
{if (typed>=#33) and (typed<=#175) then begin}
xstring:=typed;
allletters:=length (xstring);
letter:=allletters;
{end else
begin
xstring:='';
letter:=0;
allletters:=0;
end;}

start_x:=wherex;
start_y:=wherey;


{repeat}

gowrite (start_x, start_y, xstring);
write (' ');
gotoxy (start_x+letter, start_y);

{xchar:=readkey;}

{if (left (xchar))  then begin if letter>0 then dec (letter) end else
if (right (xchar)) then begin if letter<allletters then inc (letter) end else}

if (ord (xchar)=8) then erase else if (ord (xchar)=83 ) then eraseback else

{if ((ord (xchar)<>83) and (ord (xchar)<>8)) and
   ((ord (xchar)>=33) or (ord (xchar)<=126)) and
   ((allletters<=long)) then begin}

if ((((xchar<>#83) and (xchar<>'<') and (xchar<>'>'))) and (((xchar>=#224) and (xchar<=#239))
or ((xchar>=#33) and (xchar<=#175))) or (((xchar=' '))))

   and (((allletters<long))) then begin


insert (xchar, xstring, letter+1);
{xstring:=xstring+xchar;}
inc (letter);
inc (allletters);
end;

{xstring:= copy (xstring, 1, length (xstring)-1);}

if xchar=enter then begin
xstring:=xstring+';';
inc (allletters);
inc (letter);
end;
{until xchar=#13;}

gowrite (start_x, start_y, xstring);
write (' ');
gotoxy (start_x+letter, start_y);

if xchar='1' then halt;

sread3:=xstring;
end;



function passline (nstring : Word;dbs, required : Byte) : Word;
{DBS: Distance Between Strings}
{nstring - startstring}
{requried - string in string}
var x : Word;
begin
if nstring<>1 then begin
x:=(nstring-1)*dbs;
end
else x:=0;
x:=x+required-1;
passline:=x;
end;

function intstring (x : Integer) : String;
var q : Text;
    z : String;
begin
Assign (q, 'intstrin');
rewrite (q);
writeln (q, x);
close (q);

Assign (q, 'intstrin');
reset (q);
readln (q, z);
close (q);
intstring:=z;
end;

procedure wait;
var zx : char;
begin
if keypressed then Readkey;
repeat
zx:=Readkey;
until (zx='x') or (zx='') or (zx=enter) or (zx='/');
end;

procedure dwrite (wstring : String; time : LongInt);
var i : Byte;
    usetime : LongInt;
    wtext : String;
begin
wtext:=wstring+';';
usetime:=time;
if usetime=0 then usetime:=6000;
i:=1;
repeat
repeat
if wtext[i]<>';' then write (wtext[i]);
inc (i);
delay (usetime);
until (keypressed) or (i>=80) or (wtext[i]=';');

if keypressed then begin
if wtext[i]<>';' then write (wtext[i]);
repeat
if wtext[i]<>';' then inc (i);
if wtext[i]<>';' then write (wtext[i]);
until (i>=80) or (wtext[i]=';');
end;
until (i>=80) or (wtext[i]=';');
end;

procedure dwriteln (wstring : String; time : LongInt);
var i : Byte;
    usetime : LongInt;
    wtext : String;
begin
wtext:=wstring+';';
usetime:=time;
if usetime=0 then usetime:=6000;
i:=1;
repeat
repeat
if wtext[i]<>';' then write (wtext[i]);
inc (i);
delay (usetime);
until (keypressed) or (i>=80) or (wtext[i]=';');

if keypressed then begin
if wtext[i]<>';' then write (wtext[i]);
repeat
if wtext[i]<>';' then inc (i);
if wtext[i]<>';' then write (wtext[i]);
until (i>=80) or (wtext[i]=';');
end;
until (i>=80) or (wtext[i]=';');
writeln;
end;


procedure dwrite2 (wstring : String; time : LongInt; dook : Boolean);
var i : Byte;
    usetime : LongInt;
    wtext : String;
begin
if dook=true then begin
wtext:=wstring+';';
usetime:=time;
if usetime=0 then usetime:=6000;
i:=1;
repeat
repeat
if wtext[i]<>';' then write (wtext[i]);
inc (i);
delay (usetime);
until (keypressed) or (i>=80) or (wtext[i]=';');

if keypressed then begin
if wtext[i]<>';' then write (wtext[i]);
repeat
if wtext[i]<>';' then inc (i);
if wtext[i]<>';' then write (wtext[i]);
until (i>=80) or (wtext[i]=';');
end;
until (i>=80) or (wtext[i]=';');
end else write (wstring);
end;

procedure dwriteln2 (wstring : String; time : LongInt; dook : Boolean);
var i : Byte;
    usetime : LongInt;
    wtext : String;
begin
if dook=true then begin
wtext:=wstring+';';
usetime:=time;
if usetime=0 then usetime:=6000;
i:=1;
repeat
repeat
if wtext[i]<>';' then write (wtext[i]);
inc (i);
delay (usetime);
until (keypressed) or (i>=80) or (wtext[i]=';');

if keypressed then begin
if wtext[i]<>';' then write (wtext[i]);
repeat
if wtext[i]<>';' then inc (i);
if wtext[i]<>';' then write (wtext[i]);
until (i>=80) or (wtext[i]=';');
end;
until (i>=80) or (wtext[i]=';');
writeln;
end else writeln (wstring);
end;

{procedure dwriteln (wtext : String; time : LongInt);
var i : Byte;
begin
i:=1;
repeat
repeat
if wtext[i]<>';' then write (wtext[i]);
inc (i);
delay (6000);
until (keypressed) or (i>=80) or (wtext[i]=';');
if keypressed then begin
if wtext[i]<>';' then write (wtext[i]);
repeat
inc (i);
if wtext[i]<>';' then write (wtext[i]);
until (i>=80) or (wtext[i]=';');
end;
until (i>=80) or (wtext[i]=';');
writeln;
end;}



function colour (name : String) : Byte;
var x : Byte;
begin
x:=7;
if (name = 'Black') or (name='black') then x:=0 else
if (name = 'Blue') or (name='blue') then x:=1 else
if (name = 'Green') or (name='green') then x:=2 else
if (name = 'Cyan') or (name='cyan') then x:=3 else
if (name = 'Red') or (name='red') then x:=4 else
if (name = 'Magenta') or (name='magenta') then x:=5 else
if (name = 'Brown') or (name='brown') then x:=6 else
if (name = 'Lightgray') or (name='lightgray') or (name='lightgrey') then x:=7 else
if (name = 'Darkgray') or (name='darkgray') or (name='darkgrey') then x:=8 else
if (name = 'Lightblue') or (name='lightblue') then x:=9 else
if (name = 'Lightgreen') or (name='lightgreen') then x:=10 else
if (name = 'Lightcyan') or (name='lightcyan') then x:=11 else
if (name = 'Lightred') or (name='lightred') then x:=12 else
if (name = 'Lightmagenta') or (name='lightmagenta') then x:=13 else
if (name = 'Yellow') or (name='yellow') then x:=14 else
if (name = 'White') or (name='white') then x:=15 else
x:=0;
colour:=x;
end;


function filebstring (filename : String; line : Word): String;
var q : Text;
    i : Byte;
    x : String;
begin
Assign (q, filename);
reset (q);
if line<>1 then for i:=1 to line-1 do Readln (q, x);
readln (q, x);
close (q);
filebstring:=x;
end;

function filebstring2 (filename, dir : String; line : Word): String;
var q : Text;
    i : Byte;
    x : String;
begin
ChDir (dir);
Assign (q, filename);
reset (q);
if line<>1 then for i:=1 to line-1 do Readln (q, x);
readln (q, x);
close (q);
filebstring2:=x;
end;

function filebchar (filename : String; line, chars : Word): Char;
var q : Text;
    c : Byte;
    x : Char;
begin
Assign (q, filename);
reset (q);
if line<>1 then for c:=1 to line-1 do Readln (q, x);
if chars<>1 then for c:=1 to chars-1 do Read (q, x);
readln (q, x);
close (q);
filebchar:=x;
end;

procedure filewrite (filename : String; whichone, towhat : LongInt);
var q : Text;
    buffer : array [1 .. 100] of LongInt;
    x, x2 : Word;

begin
Assign (q, filename);
reset (q);
x:=1;
repeat
Readln (q, buffer[x]);
if Eof (q)= false then inc (x);
until Eof (q);
close (q);

buffer [whichone]:=towhat;
Assign (q, filename);
rewrite (q);
x2:=1;
repeat
writeln (q, buffer[x2]);
inc (x2);
until x2>x;
close (q);
end;

procedure fileswrite (filename : String; whichone : LongInt; towhat : String);

var q : Text;
    buffer : array [1 .. 100] of String [80];
    x, x2 : Word;

begin
Assign (q, filename);
reset (q);
x:=1;
repeat
Readln (q, buffer[x]);
if Eof (q)= false then inc (x);
until Eof (q);
close (q);

buffer [whichone]:=towhat;
Assign (q, filename);
rewrite (q);
x2:=1;
repeat
writeln (q, buffer[x2]);
inc (x2);
until x2>x;
close (q);
end;

function fileread (filename : String; whichone : Word) : String;
var q : Text;
    x : Word;
    y : String;
begin
assign (q, filename);
reset (q);
if whichone<>1 then for x:=1 to whichone-1 do readln (q);
Readln (q, y);
close (q);
fileread:=y;
end;

function fileread2 (filename, dir : String; whichone : Word) : String;
var q : Text;
    x : Word;
    y : String;
begin
ChDir (dir);
assign (q, filename);
reset (q);
if whichone<>1 then for x:=1 to whichone-1 do readln (q);
Readln (q, y);
close (q);
fileread2:=y;
end;

function filereadb (filename : String; whichone : Word) : Boolean;
var q : Text;
    x, z : Word;
    y : Boolean;
begin
assign (q, filename);
reset (q);
if whichone<>1 then for x:=1 to whichone-1 do readln (q);
Readln (q, z);
close (q);
if z=1 then y:=true;
if z=0 then y:=false;
filereadb:=y;
end;

function filereadvar (filename : String; whichone : Word) : LongInt;
var q : Text;
    x : Word;
    y : Word;
begin
assign (q, filename);
reset (q);
if whichone<>1 then for x:=1 to whichone-1 do readln (q);
Readln (q, y);
close (q);
filereadvar:=y;
end;


function stepcoord (step, miny, change : ShortInt) : ShortInt;
begin
stepcoord:=miny+change*(step-1);
end;

function filefound (filename : String) : Boolean;
var q : Text;
begin
Assign (q, filename);
{$I-}
Reset (q);
{$I+}
if Ioresult=0 then
begin
filefound:=true;
close (q);
end
else filefound:=false;
end;

procedure whitescreen (colour : ShortInt);
var i : Integer;
begin
textcolor (colour);
for i:=1 to 80*25 do write (chr(176));
textcolor (lightgray);
writeln (' ');
end;


function filestring (filename, start : String; anchor, lines : Integer): String;
var readvar, i : Integer;
    swapstring, teststring : String;
    q : Text;
    c : Integer;

begin
readvar:=0;
Assign (q, filename);
reset (q);

while readvar<>anchor do begin
Readln (q, teststring);  {Seek card}
if (teststring = start) then readln (q, readvar);
if (teststring = 'halt') then halt;
end;

swapstring:='';

if lines<>0 then for c:= 1 to lines do Readln (q);
Read (q, swapstring); {Read 1 string}
if (swapstring = 'halt') then halt;
filestring:=swapstring;
close (q);
end;

function filestring2 (filename, start : String; lines : Integer): String;
var q : Text;
    readstring : String;
    i : Integer;
begin
Assign (q, filename);
reset (q);

repeat
Readln (q, readstring);
until readstring=start;
if lines<>0 then for i:=1 to lines do Readln (q);
Readln (q, readstring);

close (q);

filestring2:=readstring;
end;

function fileint (filename, start, anchor : String; lines : Integer): Integer;
var readvar, i : Integer;
    teststring, maybestring : String;
    q : Text;

begin
Assign (q, filename);
reset (q);

repeat
Readln (q, teststring);  {Seek card}
if (teststring = start) then readln (q, maybestring);
until maybestring=anchor;

if lines<>0 then for i:= 1 to lines do Readln (q);
Readln (q, readvar); {Read 1 string}
close (q);

fileint:=readvar;
end;

function readint (filename, dir : String; length, line, int : Word) : Word;
var q : Text;
    i, x : Word;
begin
ChDir (dir);
Assign (q, filename);
reset (q);
if (line<>1) then for i:=1 to length*(line-1) do readln (q);
if (int<>1) then for i:=1 to int-1 do readln (q);
Readln (q, x);
close (q);
readint:=x;
end;

function readstr (filename, dir : String; length, line, int : Word) : String;
var q : Text;
    i : Word;
    x : String [80];
begin
ChDir (dir);
Assign (q, filename);
reset (q);
if (line<>1) then for i:=1 to length*(line-1) do readln (q);
if (int<>1) then for i:=1 to int-1 do readln (q);
Readln (q, x);
close (q);
readstr:=x;
end;

function left (choice : char) : Boolean;
begin
if (choice=#75) or (choice='4') then left:=true else left:=false;
end;

function right (choice : char) : Boolean;
begin
if (choice=#77) or (choice='6')then right:=true else right:=false;
end;

function up (choice : char) : Boolean;
begin
if (choice=#72) or (choice='8') then up:=true else up:=false;
end;

function down (choice : char) : Boolean;
begin
if (choice=#80) or (choice='2') then down:=true else down:=false;
end;

function rdown (choice : Char) : Boolean;
begin
if (choice=#81) or (choice='3') then rdown:=true else rdown:=false;
end;

function rup (choice : Char) : Boolean;
begin
if (choice=#73) or (choice='9') then rup:=true else rup:=false;
end;

function lup (choice : Char) : Boolean;
begin
if (choice=#71) or (choice='7') then lup:=true else lup:=false;
end;

function ldown (choice : Char) : Boolean;
begin
if (choice=#79) or (choice='1') then ldown:=true else ldown:=false;
end;


procedure horline (minx, maxx, y, colour : ShortInt; sign : Char);
var i : Integer;
begin
gotoxy (minx, y);
textcolor (colour);
for i:=minx to maxx do write (sign);
end;

procedure verline (x, miny, maxy, colour : ShortInt; sign : Char);
var i : Integer;
begin
for i:= miny to maxy do
begin
gotoxy (x, i);
textcolor (colour);
write (sign);
end;
end;

procedure scan (y, z : Integer);
var q : Text;
    x : Integer;
begin
Assign (q, 'temp.log');
reset (q);
readln (q, x);
close (q);
if z = 1 then x:=0;
Assign (q, 'temp.log');
rewrite (q);

x:=x+1;
writeln (q, x);
close (q);
if x>y then
begin
writeln ('Error located');
halt;
end;
end;

procedure box (minx, maxx, miny, maxy, colour : ShortInt; sign : Char);
var temp : ShortInt;
begin
horline (minx, maxx, miny, colour, sign);
horline (minx, maxx, maxy, colour, sign);

verline (minx, miny, maxy, colour, sign);
verline (maxx, miny, maxy, colour, sign);
end;

procedure squarebox (minx, maxx, miny, maxy, colour : ShortInt; sign : Char);
var i, i2 : Byte;
begin
textcolor (colour);
for i:=miny to maxy do begin
gotoxy (minx, i);
for i2:=minx to maxx do write (sign);
end;
end;


function oddnum (x : ShortInt) : Boolean;
begin
if x mod 2 <> 0 then oddnum:=true else oddnum:=false;
end;

Function arrow (x, miny, starty, maxy, step : Integer) : Integer;
var	 y : Integer;
	 choice : Char;
begin
y:=starty;
repeat
gotoxy (x, y);
write ('>');
gotoxy (x, y);

choice:=Readkey;
gotoxy (x, y);
write (' ');
if (choice='8') or (choice=#72)then y:=y-step;
if (choice='2') or (choice=#80)then y:=y+step;

if y>maxy then y:=miny;
if y<miny then y:=maxy;
until (choice='x') or (choice=enter) or (choice='w') or (choice='') or (choice='')
{or (choice = #10);} {(choice=#13) or (choice=#27)};
if (choice=enter) or (choice='x') or (choice='') then arrow:=trunc((y-miny)/step+1) else arrow:=0;
end;

Function sidearrow (x, miny, starty, maxy, step, isexit : Integer) : Integer;
var	 y : Integer;
	 choice : Char;
begin
y:=starty;
repeat
gotoxy (x, y);
write ('<>');
gotoxy (x, y);
choice:=Readkey;
gotoxy (x, y);
write ('  ');
if (choice='8') or (choice=#72)then y:=y-step;
if (choice='2') or (choice=#80)then y:=y+step;

if y>maxy then y:=miny;
if y<miny then y:=maxy;

until (choice='x') or (choice='w') or (choice=#13) or (choice = #75) or (choice= #77)
or (choice='4') or (choice='6')
or (choice='') or (choice='');

if (choice='x')  or (choice=#13) or (choice='') then sidearrow:=98;
if (choice='w')  or (choice='') then sidearrow:=99;
if (choice = #75) or (choice='4') then sidearrow:=-(trunc((y-miny)/step+1));
if (choice = #77) or (choice='6') then sidearrow:=(trunc((y-miny)/step+1));
if y=isexit then
begin
sidearrow:=97{trunc((y-miny)/step+1)};
end;
end;

Procedure sign (x : Byte);
var xcc : LongInt;
begin
Clrscr;
textcolor (2);
for xcc:= 1 to 10 do write (' ');
for xcc:= 1 to 11 do write ('&');
for xcc:= 1 to 5 do write (' ');
for xcc:= 1 to 4 do write ('&');
for xcc:= 1 to 13 do write (' ');
for xcc:= 1 to 12 do write ('&');
for xcc:= 1 to 1 do writeln ('&');

for xcc:= 1 to 10 do write (' ');
for xcc:= 1 to 11 do write ('&');
for xcc:= 1 to 5 do write (' ');
for xcc:= 1 to 4 do write ('&');
for xcc:= 1 to 13 do write (' ');
for xcc:= 1 to 12 do write ('&');
for xcc:= 1 to 1 do writeln ('&');

for xcc:= 1 to 10 do write (' ');
for xcc:= 1 to 3 do write ('&');
for xcc:= 1 to 13 do write (' ');
for xcc:= 1 to 4 do write ('&');
for xcc:= 1 to 13 do write (' ');
for xcc:= 1 to 3 do write ('&');
for xcc:= 1 to 1 do writeln ('&');

for xcc:= 1 to 10 do write (' ');
for xcc:= 1 to 3 do write ('&');
for xcc:= 1 to 13 do write (' ');
for xcc:= 1 to 4 do write ('&');
for xcc:= 1 to 13 do write (' ');
for xcc:= 1 to 3 do write ('&');
for xcc:= 1 to 1 do writeln ('&');

for xcc:= 1 to 10 do write (' ');
for xcc:= 1 to 11 do write ('&');
for xcc:= 1 to 5 do write (' ');
for xcc:= 1 to 4 do write ('&');
for xcc:= 1 to 13 do write (' ');
for xcc:= 1 to 8 do write ('&');
for xcc:= 1 to 1 do writeln ('&');

for xcc:= 1 to 10 do write (' ');
for xcc:= 1 to 11 do write ('&');
for xcc:= 1 to 5 do write (' ');
for xcc:= 1 to 4 do write ('&');
for xcc:= 1 to 13 do write (' ');
for xcc:= 1 to 8 do write ('&');
for xcc:= 1 to 1 do writeln ('&');

for xcc:= 1 to 10 do write (' ');
for xcc:= 1 to 3 do write ('&');
for xcc:= 1 to 13 do write (' ');
for xcc:= 1 to 4 do write ('&');
for xcc:= 1 to 13 do write (' ');
for xcc:= 1 to 3 do write ('&');
for xcc:= 1 to 1 do writeln ('&');

for xcc:= 1 to 10 do write (' ');
for xcc:= 1 to 3 do write ('&');
for xcc:= 1 to 13 do write (' ');
for xcc:= 1 to 4 do write ('&');
for xcc:= 1 to 13 do write (' ');
for xcc:= 1 to 3 do write ('&');
for xcc:= 1 to 1 do writeln ('&');

for xcc:= 1 to 10 do write (' ');
for xcc:= 1 to 11 do write ('&');
for xcc:= 1 to 5 do write (' ');
for xcc:= 1 to 12 do write ('&');
for xcc:= 1 to 5 do write (' ');
for xcc:= 1 to 3 do write ('&');
for xcc:= 1 to 1 do writeln ('&');

for xcc:= 1 to 10 do write (' ');
for xcc:= 1 to 11 do write ('&');
for xcc:= 1 to 5 do write (' ');
for xcc:= 1 to 12 do write ('&');
for xcc:= 1 to 5 do write (' ');
for xcc:= 1 to 3 do write ('&');
for xcc:= 1 to 1 do writeln ('&');
writeln('');
writeln('');
writeln('');
for xcc:= 1 to 10 do write (' ');
textcolor(14);
writeln('Games and Programs by Igor Savin aka Elven Ranger.');
for xcc:= 1 to 10 do write (' ');
writeln('You can contact me via email - Elven_Rainbow@Yahoo.com.');

textcolor (cyan);
writeln;
for xcc:= 1 to 10 do write (' ');
writeln('Any comments, RFE''s, would be appreciated.');
for xcc:= 1 to 10 do write (' ');
writeln('Please visit my brother''s homepage : www.geocities.com/chabrik/');
for xcc:= 1 to 10 do write (' ');
writeln('All my programs released to public are there.');
for xcc:= 1 to 10 do write (' ');
textcolor(7);
if x=0 then Readkey;
end;

Procedure line;
var I: ShortInt;
begin
for I:= 1 to 80 do write ('*');
end;

Procedure turnmove;
var x: Integer;
begin
for x:=1 to 4 do write(' ');
end;

Function timerate : LongInt;
var w, q : text;
    rate, tempx : LongInt;
    choice : Char;
begin
if filefound ('time.set')=false then begin
assign (w, 'time.set');
rewrite (w);
writeln (w, 1);
close (w);
end;

assign (w,'time.set');
reset (w);
read (w, rate);
close (w);

Clrscr;
writeln (' ଠ쭮 ࠡ ⮩ ணࠬ 室 ⠭ ᪮ প.');
writeln;
Readkey;

repeat
Clrscr;
writeln (' প: ',rate);
writeln;
writeln;
writeln ('1)  ');
writeln;
writeln ('2)  প  ');
writeln ('3) ਡ  প ');
writeln;
writeln ('4)  প  ');
writeln ('5)   প ');
writeln;
writeln ('6) ⠭ প');
writeln ('7) ஢ প');
writeln ('0) ');
choice:=Readkey;
if choice='1' then
begin
writeln;
writeln (' ᫮ : ');
read(tempx);
end;

if choice='2' then rate:=rate*tempx;
if choice='3' then rate:=rate+tempx;
if choice='4' then rate:=trunc(rate/tempx);
if choice='5' then rate:=rate-tempx;
if choice='6' then begin
writeln;
writeln ('প: ');
read (rate);
end;

if choice='7' then
begin
dwrite ('஢ઠ ᪮ 祭.', rate);
if keypressed then wait
else readkey;
end;

until choice='0';

assign (q,'time.set');
rewrite (q);
write (q, rate);
close (q);
timerate:=rate;
end;

procedure strigger (which : LongInt; how : Byte);
begin
filewrite ('trigg.ers', which, how);
end;

function trigger (x : LongInt) : Boolean;
begin
trigger:=filereadb ('trigg.ers', x);
end;

function value (x : LongInt) : LongInt;
begin
value:=filereadvar ('val.ues', x);
end;

function strval (x : LongInt) : String;
begin
strval:=fileread ('stri.ngs', x);
end;

procedure cval (which : LongInt; how : LongInt);
begin
filewrite ('val.ues', which, value (which) + how);
end;

procedure cstr (which : LongInt; how : String);
begin
fileswrite ('stri.ngs', which, how);
end;

procedure strigger2 (dirname : String; which : LongInt; how : Byte);
begin
ChDir (dirname);
filewrite ('trigg.ers', which, how);
end;

function getname (g : Char) : String;
var x, y : Word;
    name : String [40];
    q : Text;
begin
if g='m' then assign (q, 'm.nam') else
assign (q, 'w.nam');
reset (q);
Readln (q, x);
y:=random (x)+1;
for x:=1 to y do readln (q, name);
close (q);
getname:=name;
end;



function trigger2 (dirname : String;x : LongInt) : Boolean;
begin
ChDir (dirname);
trigger2:=filereadb ('trigg.ers', x);
end;

procedure linux (minx, maxx, miny, maxy, colour, stop : Byte);
var i, i2 : Word;
begin
textbackground (colour);

for i:=miny to maxy do begin
gotoxy (minx, miny-1+i);
for i2:=minx to maxx do write (' ');
end;
if stop<>0 then textbackground (black);
end;

function filenumber (fstart, fend : String; number : Word) : String;
var y, z : String [20];
begin
str (number, y);
z:=fstart+y+fend;
filenumber:=z;
end;
end.
