unit Features;

Interface

type pWord = ^Word;

const outline  = 5; {from up}
      fromleft = 5;
      fromright = 80-5; {5 spaces from right}
      downline = 5; {from down}

function inbox (give_x, give_y, box_x1, box_x2, box_y1, box_y2 : Word) : Boolean;

function passline (give_coord, line_1, line_2 : Word) : Boolean;
         {pass line coords 1, 2}


procedure movel;

procedure prep;

procedure changelets (x : Byte);

procedure as2 (towrite : String; letts : pWord);

procedure asd2 (towrite : String; letts : pWord);

procedure asdf2 (towrite : String; letts : pWord);

procedure as (towrite : String);

procedure asd (towrite : String);

procedure asdf (towrite : String);

function instring (part, onstring : String) : Boolean;

procedure pass (x : Byte);

procedure writef (x : string);

procedure ready;

procedure sit;

procedure hide;

procedure show;

function trigger (x : LongInt) : Boolean;

function ftrig (x : LongInt) : Boolean;

procedure strigger (which : LongInt; how : Byte);

procedure tagtoval (which : LongInt; how : String);

procedure tagtostr (which : LongInt; how : String);

procedure tagtotrig (which : LongInt; how : String);

{Get tag of numbered value}
function fvaltag (x : LongInt) : String;

function fstrtag (x : LongInt) : String;

function ftrigtag (x : LongInt) : String;

{Finds specified string}
function valtag (x : String) : LongInt;

function strtag (x : String) : String;

function trigtag (x : String) : Boolean;


{Finds specified string}
function wvaltag (x : String) : LongInt;

function wstrtag (x : String) : LongInt;

function wtrigtag (x : String) : LongInt;


{Change 'em}
procedure cvaltag (x : String; towhat : LongInt);

procedure cstrtag (x, towhat : String);

procedure ctrigtag (x : String; towhat : Byte);


procedure gotit (x : LongInt);

Implementation

Uses Crt, Blaster, Decoder;

function inbox (give_x, give_y, box_x1, box_x2, box_y1, box_y2 : Word) : Boolean;

begin
if ((give_x >= box_x1) and (give_x<=box_x2))
   and ((give_y >= box_y1) and (give_y<=box_y2)) then inbox:=true else inbox:=false;
end;


function passline (give_coord, line_1, line_2 : Word) : Boolean;

begin
if (give_coord>= line_1) and (give_coord<=line_2) then passline:=true else passline:=false;
end;



procedure addlets (x : Byte);
var i : Byte;
    q : Text;

begin
assign (q, 'lett.ers');
reset (q);
readln (q, i);
close (q);

assign (q, 'lett.ers');
rewrite (q);
writeln (q, i+x);
close (q);
end;

function checklets : Byte;
var i : Byte;
    q : Text;

begin
assign (q, 'lett.ers');
reset (q);
readln (q, i);
close (q);

checklets:=i;
end;

procedure changelets (x : Byte);
var q : Text;

begin
assign (q, 'lett.ers');
rewrite (q);
writeln (q, x);
close (q);
end;

procedure movel;
var i : Byte;

begin
for i:=1 to fromleft do write (' ');
end;

procedure asd2 (towrite : String; letts : pWord);
var i, i2 : Byte;
    nowstring : String [80];

begin
writeln;
letts^:=0;
movel;

for i:=1 to words (towrite) do begin
nowstring:=giveword (towrite, i);
i2:=length (nowstring);

if i2+letts^+fromleft<fromright then write (nowstring,' ') else begin
writeln;
letts^:=0;
movel;
write (nowstring,' ');
end;

letts^:=letts^+length (nowstring)+1;
end;

end;


procedure asd (towrite : String);
var i, i2 : Byte;
    nowstring : String [80];

begin
writeln;
movel;

for i:=1 to words (towrite) do begin
nowstring:=giveword (towrite, i);
i2:=length (nowstring);

if i2+WhereX<fromright then write (nowstring,' ') else begin
writeln;
movel;
write (nowstring,' ');
end;
end;

end;


procedure as (towrite : String);
var i, i2 : Byte;
    nowstring : String [80];

begin
writeln;
writeln;
movel;

for i:=1 to words (towrite) do begin
nowstring:=giveword (towrite, i);
i2:=length (nowstring);

if i2+WhereX<fromright then write (nowstring,' ') else begin
writeln;
movel;
write (nowstring,' ');
end;
end;

end;


procedure asdf (towrite : String);
var i, i2 : Byte;
    nowstring : String [80];

begin
for i:=1 to words (towrite) do begin
nowstring:=giveword (towrite, i);
i2:=length (nowstring);

if i2+WhereX<fromright then write (nowstring,' ') else begin
writeln;
movel;
write (nowstring,' ');
end;
end;

end;









procedure asdf2 (towrite : String; letts : pWord);
var i, i2 : Byte;
    nowstring : String [80];

begin
{movel;}

for i:=1 to words (towrite) do begin
nowstring:=giveword (towrite, i);
i2:=length (nowstring);

if i2+letts^+fromleft<fromright then write (nowstring,' ') else begin
writeln;
letts^:=0;
movel;
write (nowstring,' ');
end;

letts^:=letts^+length (nowstring)+1;
end;

end;

procedure as2 (towrite : String; letts : pWord);
var i, i2 : Byte;
    nowstring : String [80];

begin
writeln; writeln; movel;
letts^:=0;

for i:=1 to words (towrite) do begin
nowstring:=giveword (towrite, i);
i2:=length (nowstring);

if i2+letts^+fromleft<fromright then write (nowstring,' ') else begin
writeln;
letts^:=0;
movel;
write (nowstring,' ');
end;

letts^:=letts^+ length (nowstring)+1;
end;

end;


procedure prep;
var i : Byte;
begin
Clrscr;

if outline<>0 then for i:=1 to outline do writeln;
end;


function instring (part, onstring : String) : Boolean;
var i : Byte;

begin
instring:=false;
i:=pos (part, onstring);
if ((i>0) and (onstring[i-1]=' ')) or ((i=1)) then instring:=true;
end;

procedure pass (x : Byte);
var i : Byte;
begin
for i:=1 to x do writeln;
end;

procedure writef (x : string);
var i : Byte;
begin
if i<>0 then for i:=1 to outline do write (' ');
writeln (x);
end;

procedure ready;
var zx : char;
begin
if keypressed then Readkey;
repeat
zx:=Readkey;
until (zx='x') or (zx='');
prep;
changelets (0);
end;

procedure sit;
begin
if keypressed then readkey;
if keypressed then readkey;
readkey;
end;

procedure hide;
begin
{ASM
                MOV     AH,1     
                MOV     CX,2000h
                INT     10h
End;
}
end;

procedure show;
begin
{ASM
                MOV     AX,03h
                INT     10h
END;
}
end;

procedure strigger (which : LongInt; how : Byte);
begin
filewrite ('trigg.ers', which, how);
end;

function trigger (x : LongInt) : Boolean;
begin
trigger:=filereadb ('trigg.ers', x);
end;

function ftrig (x : LongInt) : Boolean;
var trig : Boolean;
begin
trig:=filereadb ('trigg.ers', x);
if trig=false then ftrig:=true else ftrig:=false;
end;

procedure gotit (x : LongInt);
begin
filewrite ('trigg.ers', x, 1);
end;

procedure tagtoval (which : LongInt; how : String);
begin
fileswrite ('valt.ags', which, how);
end;

function fvaltag (x : LongInt) : String;
begin
fvaltag:=fileread ('valt.ags', x);
end;

procedure tagtostr (which : LongInt; how : String);
begin
fileswrite ('strt.ags', which, how);
end;

function fstrtag (x : LongInt) : String;
begin
fstrtag:=fileread ('strt.ags', x);
end;

procedure tagtotrig (which : LongInt; how : String);
begin
fileswrite ('trigt.ags', which, how);
end;

function ftrigtag (x : LongInt) : String;
begin
ftrigtag:=fileread ('trigt.ags', x);
end;

function wvaltag (x : String) : LongInt;
var counter : LongInt;
    readtag : String [80];
    q : Text;

begin
assign (q, 'valt.ags');
reset (q);
counter:=0;

repeat
inc (counter);
readln (q, readtag);
until (Eof (q)) or (instring (x, readtag));

if (Eof (q)) then begin Clrscr; writeln ('Error: No such tag!'); Readkey; halt; end  else wvaltag:=counter;
end;

function wstrtag (x : String) : LongInt;
var counter : LongInt;
    readtag : String [80];
    q : Text;

begin
assign (q, 'strt.ags');
reset (q);
counter:=0;

repeat
inc (counter);
readln (q, readtag);
until (Eof (q)) or (instring (x, readtag));

if (Eof (q)) then begin Clrscr; writeln ('Error: No such tag!'); Readkey; halt; end else wstrtag:=counter;
end;

function wtrigtag (x : String) : LongInt;
var counter : LongInt;
    readtag : String [80];
    q : Text;

begin
assign (q, 'trigt.ags');
reset (q);
counter:=0;

repeat
inc (counter);
readln (q, readtag);
until (Eof (q)) or (instring (x, readtag));

if (Eof (q)) then begin Clrscr; writeln ('Error: No such tag!'); Readkey; halt; end  else wtrigtag:=counter;
end;

function valtag (x : String) : LongInt;
begin
valtag:=value (wvaltag (x));
end;

function strtag (x : String) : String;
begin
strtag:=strval (wstrtag (x));
end;

function trigtag (x : String) : Boolean;
begin
trigtag:=trigger (wtrigtag (x));
end;

procedure cvaltag (x : String; towhat : LongInt);
begin
cval (wvaltag (x), towhat);
end;

procedure cstrtag (x, towhat : String);
begin
cstr (wstrtag (x), towhat);
end;

procedure ctrigtag (x : String; towhat : Byte);
begin
strigger (wtrigtag (x), towhat);
end;

end.
